
rc = require 'vectorcaster'

function love.load()
	love.keyboard.setKeyRepeat(true)

	love.graphics.setDefaultFilter('nearest', 'nearest')
	
	cvs_raycaster = love.graphics.newCanvas(love.graphics.getWidth(), love.graphics.getHeight())
end

function love.update(dt)
	if love.keyboard.isDown('escape') then love.event.quit() end

	rc:updatePos()

	--if love.keyboard.isDown('m') then Vectorcaster.map = dofile("rayblaster/sampmap.lua") end


end

function love.filedropped( f )
	file = f:read()

	rc:loadMap(file)

	f:close()
end

function love.keypressed(k)

	if k == "o" then
		rc.sprites = {}	
		for i=1, 12 do
			for y = 1, 12 do
				table.insert(rc.sprites, spr:New(i+0.5, y+0.5, "Kwarztsov.png") )
			end
		end
	end

	if k == 'left' then
		rc.counter = rc.counter + 1
		local oldDirX = rc.dirX
		rc.dirX = rc.dirX * math.cos(-rc.rotSpeed) - rc.dirY * math.sin(-rc.rotSpeed)
		rc.dirY = oldDirX * math.sin(-rc.rotSpeed) + rc.dirY * math.cos(-rc.rotSpeed)

		local oldPlaneX = rc.planeX
		rc.planeX = rc.planeX * math.cos(-rc.rotSpeed) - rc.planeY * math.sin(-rc.rotSpeed)
		rc.planeY = oldPlaneX * math.sin(-rc.rotSpeed) + rc.planeY * math.cos(-rc.rotSpeed)
	end
	if k == 'right' then
		rc.counter = rc.counter + 1
		local oldDirX = rc.dirX
		rc.dirX = rc.dirX * math.cos(rc.rotSpeed) - rc.dirY * math.sin(rc.rotSpeed)
		rc.dirY = oldDirX * math.sin(rc.rotSpeed) + rc.dirY * math.cos(rc.rotSpeed)

		local oldPlaneX = rc.planeX
		rc.planeX = rc.planeX * math.cos(rc.rotSpeed) - rc.planeY * math.sin(rc.rotSpeed)
		rc.planeY = oldPlaneX * math.sin(rc.rotSpeed) + rc.planeY * math.cos(rc.rotSpeed)
	end

	rc:keypressed(k)

	if k == "z" then rc.highlight = rc.highlight - 1 end
	if k == "c" then rc.highlight = rc.highlight + 1 end

end

function love.draw()
	-- Draw the map
	--[[]
	love.graphics.setColor(1, 1, 1)
	for row=1, #rc.map do
	for col=1, #rc.map[row] do
		if rc.map[row][col] > 0 then love.graphics.rectangle('fill', (col-1)*100, (row-1)*100, 100, 100) end
	end
	end--]]
    
    love.graphics.setCanvas(cvs_raycaster)
    love.graphics.clear()
		rc:raycast()


    love.graphics.setCanvas()

    love.graphics.setColor(1, 1, 1)
	love.graphics.draw(cvs_raycaster, 0, 0)
	
	love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )), 10, 10)
end