textureMetatable = {}
textureMethods = {}


function textureMethods.drawStrip(self, strip, x, y, sy)
	love.graphics.draw(self.image, self.strips[strip], x, y, 0, 1, sy)
end

function textureMethods.drawPointStrip(self, strip, x1, y1, x2, y2)
	-- FInd distance between two point
	local pointDistance = math.abs(math.sqrt( (x1 - x2)^2 + (y1 - y2)^2 ))

	love.graphics.print("X1: "..x1.."\tY1: "..y1, 200, 0)
	love.graphics.print("X2: "..x2.."\tY2: "..y2, 200, 12)

	-- Fixes the issue of line going down when first point is higher
	if y2 >= y1 then pointDistance = -pointDistance end

	-- Find the angle
	local xDist = x2 - x1
	local yDist = y2 - y1
	angle = -math.atan(xDist / yDist) -- Why is angle negative???

	love.graphics.draw(self.image, self.strips[strip], x1, y1, angle, 1, -(pointDistance / 64), 0, 0, 0, 0)
	--love.graphics.draw(drawable, x, y, r, sx, sy, ox, oy, kx, ky)

end








-- ==================================================================================
-- ==================================================================================

function textureMethods.drawPixel(self, col, row, x, y)
	--print("============ Drawing Pixel stuff ============")
	--print(self)
	love.graphics.draw(self.image, self.pixels[col][row], x, y)
end


-- ==================================================================================
-- ==================================================================================





function textureMethods.testDraw(self, x, y, sy, r)
	--print(#self.strips)
	for strip=1, #self.strips do
		love.graphics.draw(self.image, self.strips[strip], x+strip, y, r, 1, sy)
	end		
end

function textureMethods.getWidth(self)
	return self.image:getWidth()
end

textureMetatable.__index = textureMethods





Texture = {}

function Texture:New(filename)
	tex = {}
	love.graphics.setDefaultFilter('nearest', 'nearest')

	tex.image = love.graphics.newImage("graphics/"..filename)
	tex.strips = {}

	for i=0, tex.image:getWidth()-1 do
		local imageWidth = tex.image:getWidth()
		local imageHeight = tex.image:getHeight()

		table.insert(tex.strips, love.graphics.newQuad(i, 0, 1, imageHeight, imageWidth, imageHeight) )

	end



-- ==================================================================================\
-- ==================================================================================

	tex.pixels = {}
	for col = 1, tex.image:getWidth() do
		tex.pixels[col] = {}
		for row = 1, tex.image:getHeight() do
			table.insert(tex.pixels[col], love.graphics.newQuad(row, col, 1, 1, tex.image:getWidth(), tex.image:getHeight()))
			--tex.pixels[#tex.pixels+1] = )
		end
	end

-- ==================================================================================
-- ==================================================================================








	setmetatable(tex, textureMetatable)

	return tex
end

return Texture