tx = require 'texture'
spr = require 'sprite'
json = require 'json'


Vectorcaster = {}
Vectorcaster.sprites = {}

function Vectorcaster:loadMap( fileData )
	decodedMap = json.decode(fileData)

	--print(decodedMap[3])
	
	self.map = decodedMap[1]

	for curSprite = 1, #decodedMap[2] do
		table.insert(self.sprites, spr:New(decodedMap[2][curSprite].x, decodedMap[2][curSprite].y, decodedMap[2][curSprite].texture))
	end


end

src = love.filesystem.getSource()
mapFile = io.open(src.."/../5edcmaker/map.txt", "r")
mapData = mapFile:read()
Vectorcaster:loadMap(mapData)

-- Define texture objects
Vectorcaster.textures = {
	tx:New("dungeon_wall.png"),
	tx:New("wood_wall.png"),
	tx:New("tile.png"),
	tx:New("epic.png"),
	tx:New("epic2.png")
}

player = {x = 1, y = 1} -- This player table needs to be in it's own file at some point

abs = math.abs

Vectorcaster.screenW = 700
Vectorcaster.screenH = 500

Vectorcaster.posX, Vectorcaster.posY = player.x+0.5, player.y+0.5
-- Dis a vector, eh? It tell us da direction o' da playah!
Vectorcaster.dirX, Vectorcaster.dirY = 1, 0

-- Dis one tell us o' da projection plane! (It's gotta be parallel wid da playah direction or it'll break)
Vectorcaster.planeX, Vectorcaster.planeY = 0, 1.30

Vectorcaster.coreSpeed = 1
Vectorcaster.rotSpeed = 0.2

Vectorcaster.mode = "still"
Vectorcaster.countdown = 0
Vectorcaster.counter = 0

Vectorcaster.moveSpeed = 0.15

Vectorcaster.highlight = 1

cmap_counter = 0 -- Makes the map loader happy

function round(num, numDecimalPlaces)
	local mult = 10^(numDecimalPlaces or 0)
	return math.floor(num * mult + 0.5) / mult
end

function Vectorcaster:keypressed(k)
	if self.mode == "still" then

		if k == "e" then
			self.mode = "spinningRight"
			self.countdown = 6
		end

		if k == "q" then
			self.mode = "spinningLeft"
			self.countdown = 6
		end

		mapX, mapY = math.floor(self.posX), math.floor(self.posY)
		
		if k == "w" then
				if self.dirX == 0  and self.dirY == -1 then self.mode = "moveNorth"
			elseif self.dirX == 0  and self.dirY == 1  then self.mode = "moveSouth"
			elseif self.dirX == 1  and self.dirY == 0  then self.mode = "moveEast"
			elseif self.dirX == -1 and self.dirY == 0  then self.mode = "moveWest"
			end
			
		elseif k == "a" then
				if self.dirX == 0  and self.dirY == -1 then self.mode = "moveWest"
			elseif self.dirX == 0  and self.dirY == 1  then self.mode = "moveEast"
			elseif self.dirX == 1  and self.dirY == 0  then self.mode = "moveNorth"
			elseif self.dirX == -1 and self.dirY == 0  then self.mode = "moveSouth"
			end

		elseif k == "s" then
				if self.dirX == 0  and self.dirY == -1 then self.mode = "moveSouth"
			elseif self.dirX == 0  and self.dirY == 1  then self.mode = "moveNorth"
			elseif self.dirX == 1  and self.dirY == 0  then self.mode = "moveWest"
			elseif self.dirX == -1 and self.dirY == 0  then self.mode = "moveEast"
			end
		
		elseif k == "d" then
				if self.dirX == 0  and self.dirY == -1 then self.mode = "moveEast"
			elseif self.dirX == 0  and self.dirY == 1  then self.mode = "moveWest"
			elseif self.dirX == 1  and self.dirY == 0  then self.mode = "moveSouth"
			elseif self.dirX == -1 and self.dirY == 0  then self.mode = "moveNorth"
			end

		end

		if string.sub(self.mode, 1, 4) == "move" then
			self.counter = math.floor(1 / self.moveSpeed)
		end


	end
end

function Vectorcaster:updatePos()


	if self.mode == "spinningRight" then
		if self.countdown > 0 and not love.keyboard.isDown('t') then
			self.countdown = self.countdown - 1

			local oldDirX = self.dirX
			self.dirX = self.dirX * math.cos(self.rotSpeed) - self.dirY * math.sin(self.rotSpeed)
			self.dirY = oldDirX * math.sin(self.rotSpeed) + self.dirY * math.cos(self.rotSpeed)

			local oldPlaneX = self.planeX
			self.planeX = self.planeX * math.cos(self.rotSpeed) - self.planeY * math.sin(self.rotSpeed)
			self.planeY = oldPlaneX * math.sin(self.rotSpeed) + self.planeY * math.cos(self.rotSpeed)
			--print("Direction: "..self.dirX..", "..self.dirY)
			--print("Plane: "..self.planeX..", "..self.planeY)
		else
			--print("--- end of turn --- ")
			self.countdown = 0
			self.mode = "still"
			self.dirX = round(self.dirX)
			self.dirY = round(self.dirY)

			self.planeX = round(self.planeX)
			if self.planeX == 1 then self.planeX = 1.3 end
			if self.planeX == -1 then self.planeX = -1.3 end

			self.planeY = round(self.planeY)
			if self.planeY == 1 then self.planeY = 1.3 end
			if self.planeY == -1 then self.planeY = -1.3 end
		end
	end

	if self.mode == "spinningLeft" then
		if self.countdown > 0 and not love.keyboard.isDown('t') then
			self.countdown = self.countdown - 1

			local oldDirX = self.dirX
			self.dirX = self.dirX * math.cos(-self.rotSpeed) - self.dirY * math.sin(-self.rotSpeed)
			self.dirY = oldDirX * math.sin(-self.rotSpeed) + self.dirY * math.cos(-self.rotSpeed)

			local oldPlaneX = self.planeX
			self.planeX = self.planeX * math.cos(-self.rotSpeed) - self.planeY * math.sin(-self.rotSpeed)
			self.planeY = oldPlaneX * math.sin(-self.rotSpeed) + self.planeY * math.cos(-self.rotSpeed)

		else
			self.countdown = 0
			self.mode = "still"
			
			-- Turn correction because decimals in lua aren't very good
			self.dirX = round(self.dirX)
			self.dirY = round(self.dirY)

			self.planeX = round(self.planeX)
			if self.planeX == 1 then self.planeX = 1.3 end
			if self.planeX == -1 then self.planeX = -1.3 end 
			
			self.planeY = round(self.planeY)
			--if math.abs(round(self.planeY)) > 1 then self.planeY = math.floor(self.planeY)
			if self.planeY == 1 then self.planeY = 1.3 end
			if self.planeY == -1 then self.planeY = -1.3 end
		end
	end

	

	if self.mode == "moveNorth" then
		self.counter = self.counter - 1
		if self.map[mapY][mapX+1] == 0 then
			self.posY = self.posY - (self.moveSpeed)
		end

	elseif self.mode == "moveWest" then
		self.counter = self.counter - 1
		if self.map[mapY+1][mapX] == 0 then 
			self.posX = self.posX - (self.moveSpeed)
		end
			
	elseif self.mode == "moveSouth" then
		self.counter = self.counter - 1
		if self.map[mapY+2][mapX+1] == 0 then
			self.posY = self.posY + (self.moveSpeed)
		end
	elseif self.mode == "moveEast" then
		self.counter = self.counter - 1
		if self.map[mapY+1][mapX+2] == 0 then
			self.posX = self.posX + (self.moveSpeed)
		end
	end 

	if string.sub(self.mode, 1, 4) == "move" and self.counter < 1 then
		self.counter = 0 
		self.mode = "still"
		self.posX = round(self.posX / 0.5) * 0.5 -- Round to nearest 0.5
		self.posY = round(self.posY / 0.5) * 0.5
	end




	if love.keyboard.isDown("r") then
		self.dirX, self.dirY, self.planeX, self.planeY = 1, 0, 0, 1.30
	end

end

function rshift(num, shift)
	return math.floor(num / 2 ^ shift)
end

function Vectorcaster:raycast()
	love.graphics.setColor(1, 1, 1)
	love.graphics.print("Dir Vector: "..self.dirX..", "..self.dirY, 0, self.screenH)
	love.graphics.print("Plane Vector: "..self.planeX..", "..self.planeY, 0, self.screenH + 12)
	love.graphics.print("Counter: "..self.counter, 0, self.screenH + 24)
	love.graphics.print("Player Position: "..self.posX..", "..self.posY, 0, self.screenH+36)
	love.graphics.print("Mode: "..self.mode, 0, self.screenH+48)
	
	-- Draw the background.
	love.graphics.setColor(0.4, 0.4, 0.4)
	love.graphics.rectangle('fill', 0, 0, self.screenW, self.screenH/2)

	love.graphics.setColor(0.4, 0.4, 0.4)
	love.graphics.rectangle('fill', 0, self.screenH / 2, self.screenW, self.screenH/2)

	local zBuffer = {}

	-- Shoot some rays!
	for x = 0, self.screenW do
		-- Current ray position
		local cameraX = 2 * x / self.screenW - 1

		-- Vector that is the current ray
		local rayDirX = self.dirX + self.planeX * cameraX
		local rayDirY = self.dirY + self.planeY * cameraX

		-- What box o' da map am I in?
		local mapX, mapY = math.floor(self.posX), math.floor(self.posY)

		-- dx/2 and dy/2 -> calculated later
		local sideDistX, sideDistY

		-- dx and dy
		local deltaDistX = abs(1 / rayDirX)
		local deltaDistY = abs(1 / rayDirY)

		-- Used later to find the length of the ray
		local perpWallDist

		-- When we start DDA, we use these to figure out whether we go up, down, left or right
		-- Either +1 or -1
		local stepX, stepY

		-- Did we hit a wall?
		local hit = 0
		local side -- Was it a NS wall hit or a EW wall hit

		if rayDirX < 0 then
			stepX = -1
			sideDistX = (self.posX - mapX) * deltaDistX
		else
			stepX = 1
			sideDistX  = (mapX + 1 - self.posX) * deltaDistX
		end

		if rayDirY < 0 then
			stepY = -1
			sideDistY = (self.posY - mapY) * deltaDistY
		else
			stepY = 1
			sideDistY = (mapY + 1 - self.posY) * deltaDistY
		end

		-- Yay, now DDA happens
		while hit == 0 do
			if sideDistX < sideDistY then
				sideDistX = sideDistX + deltaDistX
				mapX = mapX + stepX
				side = 0
			else
				sideDistY = sideDistY + deltaDistY
				mapY = mapY + stepY
				side = 1
			end


			if self.map[mapY+1][mapX+1] > 0 then -- we add one here because ARRAYS START AT ONE (in lua)
				hit = self.map[mapY+1][mapX+1]
			end
		end


		if side == 0 then
			perpWallDist = (mapX - self.posX + (1 - stepX) / 2) / rayDirX
		else
			perpWallDist = (mapY - self.posY + (1 - stepY) / 2) / rayDirY
		end

		-- Find the height of the line
		lineHeight = self.screenH / perpWallDist / 2.5 -- Not local because I use it for floorcasting

		local drawStart = (-lineHeight / 2) + self.screenH / 2
		drawEnd = lineHeight / 2 + self.screenH / 2 -- this is used in floorcasting

		love.graphics.setColor(1, 1, 1)
	
		if side == 0 then
			wallX = self.posY + perpWallDist * rayDirY
		else
			wallX = self.posX + perpWallDist * rayDirX
		end

					-- Set the color based on distance = lighting
					--[[
					local r, g, b, a = love.graphics.getColor()
					local colorMod = perpWallDist - 2.5
					if colorMod < 0 then colorMod = 0 end
					love.graphics.setColor(r-colorMod, g-colorMod, b-colorMod)
					--]]

		-- Scale textures and draw
		local texScaleWidth = self.textures[hit].image:getWidth()
		local texScaleHeight = self.textures[hit].image:getHeight()

		wallX = wallX - math.floor(wallX)
		wallX = math.floor(wallX * texScaleWidth) -- texture width
		wallX = wallX + 1
		if wallX > texScaleWidth then wallX = texScaleWidth + 1 end

		texHeight = lineHeight / texScaleHeight
		
		-- Debug info for selected ray
		if love.mouse.getX() == x then
			love.graphics.setColor(0, 1, 0)

			if love.mouse.isDown(1) then
				print(perpWallDist)
			end
		end

		local drawEnd = lineHeight / 2 + self.screenH / 2
		
		if wallX >= 1 and wallX <= self.textures[hit].image:getWidth() then
			self.textures[hit]:drawStrip( math.floor(wallX), x, drawStart, texHeight) -- sy
			-- ooh, and store the z level too!
			zBuffer[x] = perpWallDist
		else
			error("Woah! Either a strip wasnt found or wallX is screwed up again")
		end

		












-- ==================================================================================
-- ==================================================================================

		-- Floor drawing...
		-- Idea: Find the intersections of the invisible grid, and save those points. Draw the flat floor texture grafted on to there.	
		local h = self.screenH
		local floorXWall, floorYWall

		if side == 0 then
			if rayDirX > 0 then
				floorXWall = mapX
			elseif rayDirX < 0 then
				floorXWall = mapX + 1.0
			end
			
			floorYWall = mapY + wallX

		elseif side == 1 then
			floorXWall = mapX + wallX
			
			if rayDirY > 0 then
				floorYWall = mapY
			elseif rayDirY < 0 then
				floorYWall = mapY + 1.0
			end

		end

		local distWall, distPlayer, currentDist

		distWall = perpWallDist
		distPlayer = 0

		if drawEnd > 10000 then drawEnd = h end

		for y = drawEnd+1, h do
			local currentDist = h / (2.0 * y - h)
			local weight = (currentDist - distPlayer) / (distWall - distPlayer)


			local currentFloorX = weight * floorXWall + (1.0 - weight) * self.posX;
			local currentFloorY = weight * floorYWall + (1.0 - weight) * self.posY;

			local floorTexX, floorTexY;
			local texWidth, texHeight = self.textures[1]:getWidth(), self.textures[1]:getWidth()
		    floorTexX = round(currentFloorX * texWidth) % texWidth;
		    floorTexY = round(currentFloorY * texHeight) % texHeight;



		    self.textures[1]:drawPixel(floorTexX+1, floorTexY+1, math.floor(x), math.ceil(y))
		end

-- ==================================================================================
-- ==================================================================================









	end



	-- Sprite casting time

	-- Sort the sprites based on distance from the player so we know what to draw first.
	-- 1. Get the distance from player and store it in every sprite
	-- 2. Store the distances from player into another array, sort that array
	-- 3. Iterate through the sprite list and see if a sprite matches the distance from player from the sorted array
	-- 4. Move the sprite from the unsorted listed into the sorted list, get rid of the sprite from the unsorted list and the distance to player from the distance sorted list
	spriteDistances = {}

	unsortedSprites = {}

	for sprite = 1, #self.sprites do


		local spriteX, spriteY = self.sprites[sprite].x, self.sprites[sprite].y

		local playerDistToSprite = math.sqrt( (spriteX - self.posX)^2 + (spriteY - self.posY)^2 )
		if love.keyboard.isDown("i") then
			--print(self.posX, self.posY)
			if sprite == 1 then print(playerDistToSprite) end
		end

		self.sprites[sprite].distToPlayer = playerDistToSprite

	end


	--self.sprites = {}
	function quicksort(array, p, r)
	    p = p or 1
	    r = r or #array
	    if p < r then
	        q = partition(array, p, r)
	        quicksort(array, p, q - 1)
	        quicksort(array, q + 1, r)
	    end
	end

	function partition(array, p, r)
	    local x = array[r]
	    local i = p - 1
	    for j = p, r - 1 do
	        if array[j] <= x then
	            i = i + 1
	            local temp = array[i]
	            array[i] = array[j]
	            array[j] = temp
	        end
	    end
	    local temp = array[i + 1]
	    array[i + 1] = array[r]
	    array[r] = temp
	    return i + 1
	end

	quicksort(self.sprites, 1, #self.sprites)







	for sprite = 1, #self.sprites do
		local spriteDist = ((self.posX - self.sprites[sprite].x) * (self.posX - self.sprites[sprite].x) + (self.posY - self.sprites[sprite].y) * (self.posY - self.sprites[sprite].y))

		local spriteX = self.sprites[sprite].x - self.posX
		local spriteY = self.sprites[sprite].y - self.posY

		local invDet = 1 / (self.planeX * self.dirY - self.dirX * self.planeY)

		local transformX = invDet * (self.dirY * spriteX - self.dirX * spriteY)
		local transformY = invDet * (-self.planeY * spriteX + self.planeX * spriteY)

		local spriteScreenX = math.floor( (self.screenW / 2) * (1 + transformX / transformY)  )

		local spriteHeight = math.abs(math.floor( self.screenH / transformY ))
		spriteHeight = math.floor(spriteHeight / 2) 
		local drawStartY = -spriteHeight / 2 + self.screenH / 2

		local spriteWidth = math.abs(math.floor(self.screenH / (transformY)))
		spriteWidth = spriteWidth / 2
		local drawStartX = math.floor(-spriteWidth / 2 + spriteScreenX)
		local drawEndX = math.floor(spriteWidth / 2 + spriteScreenX)

		love.graphics.setColor(1, 1, 1)

		for strip = drawStartX, drawEndX do
			if transformY > 0 and
			strip > 0 and
			strip < self.screenW and
			transformY < zBuffer[strip] then
				local drawStrip = math.floor( (256 * (strip - (-spriteWidth / 2 + spriteScreenX)) * 64 / spriteWidth) / 256)
				--print(drawStrip)
				if drawStrip == 0 then drawStrip = 64 end
				--print(drawStrip)
				if drawStrip > 0 then
				self.sprites[sprite]:drawStrip(drawStrip, strip, drawStartY, spriteHeight / 64) end
			end
		end
	end
end

function round(n)
	return n + 0.5 - (n + 0.5) % 1
end

return Vectorcaster